package cn.hiber.webapp;

import com.mchange.v2.c3p0.ComboPooledDataSource;
import org.hibernate.SessionFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.orm.hibernate4.HibernateTemplate;
import org.springframework.orm.hibernate4.HibernateTransactionManager;
import org.springframework.orm.hibernate4.LocalSessionFactoryBean;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.sql.DataSource;
import java.beans.PropertyVetoException;
import java.util.Properties;

/**
 * Created by Smile on 2018/4/2.
 */
@Configuration
@EnableTransactionManagement
public class PersistConfig {
    /**
     * C3P0数据源
     */
    @Bean
    public ComboPooledDataSource dataSource() throws PropertyVetoException {
        ComboPooledDataSource ds = new ComboPooledDataSource();
        ds.setDriverClass("com.mysql.jdbc.Driver");
        ds.setJdbcUrl("jdbc:mysql://localhost:3306/studydb?characterEncoding=utf8");
        ds.setUser("root");
        ds.setPassword("smile#2002");
        ds.setMaxPoolSize(10);
        ds.setMinPoolSize(1);
        ds.setInitialPoolSize(2);
        ds.setMaxIdleTime(20);
        ds.setAcquireIncrement(3);
        ds.setIdleConnectionTestPeriod(60);
        ds.setUnreturnedConnectionTimeout(190);
        ds.setCheckoutTimeout(20000);
        ds.setAcquireRetryAttempts(30);
        return ds;
    }


    /**
     * Hibernate Session Factory Bean
     * 须放在root上下文中，否则其他组件（如 OpenSessionInViewFilter）找不到该 Bean
     * Hibernate4 中 LocalSessionFactoryBean 合并了 Hibernate3 Local 与 Annotation 的功能
     */
    @Bean(name="sessionFactory")
    /** for Hibernate 3 */
    /*public AnnotationSessionFactoryBean sessionFactory(DataSource dataSource) {
        AnnotationSessionFactoryBean sessionFactory = new AnnotationSessionFactoryBean();
        sessionFactory.setDataSource(dataSource);
        sessionFactory.setPackagesToScan(new String[] { "cn.hiber.domain" });
        Properties props = new Properties();
        props.setProperty("dialecct", "org.hibernate.dialect.MySQLDialect");
        props.setProperty("hibernate.show_sql", "true");
        props.setProperty("hibernate.format_sql", "false");
        props.setProperty("hibernate.cache.use_second_level_cache", "false");
        props.setProperty("hibernate.cache.provider_class", "org.hibernate.cache.EhCacheProvider");
        //props.setProperty("hibernate.current_session_context_class", "thread");
        sessionFactory.setHibernateProperties(props);
        return sessionFactory;
    }*/
    /** for Hibernate 4 */
    public LocalSessionFactoryBean sessionFactory(DataSource dataSource) {
        LocalSessionFactoryBean sessionFactory = new LocalSessionFactoryBean();
        sessionFactory.setDataSource(dataSource);
        sessionFactory.setPackagesToScan(new String[] { "cn.hiber.domain" });
        Properties props = new Properties();
        props.setProperty("dialecct", "org.hibernate.dialect.MySQLDialect");
        props.setProperty("hibernate.show_sql", "true");
        props.setProperty("hibernate.format_sql", "false");
        //props.setProperty("hibernate.cache.use_second_level_cache", "false");
        //props.setProperty("hibernate.cache.provider_class", "org.hibernate.cache.EhCacheProvider");
        //props.setProperty("hibernate.current_session_context_class", "thread");
        sessionFactory.setHibernateProperties(props);
        return sessionFactory;
    }

    /**
     * 早期Hibernate编程依赖Spring 的 HibernateTemplate
     * (org.springframework.orm.hibernate3.HibernateTemplate)
     */
    @Bean
    public HibernateTemplate hibernateTemplate(SessionFactory sessionFactory) {
        HibernateTemplate hibernateTemplate = new HibernateTemplate(sessionFactory);
        return hibernateTemplate;
    }

    /**
     * HibernateTransactionManager
     */
    @Bean
    public HibernateTransactionManager transactionManager(SessionFactory sessionFactory) {
        HibernateTransactionManager transactionManager = new HibernateTransactionManager(sessionFactory);
        return transactionManager;
    }

    /*@Bean
    public PlatformTransactionManager dataSourceTransactionManager(DataSource dataSource){
        DataSourceTransactionManager dataSourceTransactionManager = new DataSourceTransactionManager();
        dataSourceTransactionManager.setDataSource(dataSource);
        return dataSourceTransactionManager;
    }*/

}
